



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Ioc-依赖注入的几种方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Ioc-依赖注入的几种方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 21:55:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p><strong>一 setter方法注入</strong></p>
<p>配置文件如下：</p>
<p>&lt;bean id="helloAction" class="org.yoo.action.SpringSetterHelloAction"&gt;<br />&lt;!-- setter injection using the nested &lt;ref/&gt; element --&gt;<br />&lt;property name="helloservice"&gt;&lt;ref bean="helloService"/&gt;&lt;/property&gt;<br />&lt;!--可以不设置类型 --&gt;<br />&lt;property name="name" value="yoo"&gt;&lt;/property&gt;<br />&lt;/bean&gt;</p>
<p>action实现类中代码：</p>
<p>private IHelloService helloservice;<br />private String name ;<br />public void sayHello(){<br />helloservice.sayHello();<br />System.out.println(this.name);<br />}</p>
<p>public void setHelloservice(IHelloService helloservice) {<br />this.helloservice = helloservice;<br />}</p>
<p>public void setName(String name) {<br />this.name = name;<br />}</p>
<p>这里的name和helloservice都采用属性的setter方法注入。即类中设置一个全局属性，并对属性有setter方法，以供容器注入。</p>
<p><strong>二 构造器注入</strong></p>
<p><a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">spring</a>也支持构造器注入，也即有些资料中的构造子或者构造函数注入。</p>
<p>先看配置文件：</p>
<p>&lt;!--普通构造器注入--&gt;<br />&lt;bean id="helloAction" class="org.yoo.action.ConstructorHelloAction"&gt;<br />&lt;!--type 必须为<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>.lang.String 因为是按类型匹配的，不是按顺序匹配--&gt;</p>
<p>&lt;constructor-arg type="java.lang.String" value="yoo"/&gt;<br />&lt;!-- 也可以使用index来匹配--&gt;<br />&lt;!--&lt;constructor-arg index="1" value="42"/&gt;--&gt;<br />&lt;constructor-arg&gt;&lt;ref bean="helloService"/&gt;&lt;/constructor-arg&gt;<br />&lt;/bean&gt;</p>
<p>action实现类中代码：</p>
<p>private HelloServiceImpl helloservice;<br />private String name ;</p>
<p>public SpringConstructorHelloAction(HelloServiceImpl helloservice,String name){<br />this.helloservice = helloservice;<br />this.name = name ;<br />}</p>
<p>@Override<br />public void sayHello() {<br />helloservice.sayHello();<br />System.out.println(this.name);<br />}</p>
<p>同样设置2个属性，然后在构造函数中注入。</p>
<p><strong>三静态工厂注入</strong></p>
<p>配置文件如下：</p>
<p>&lt;!--静态工厂构造注入--&gt;</p>
<p>&lt;!--注意这里的class 带factory-method参数--&gt;</p>
<p>&lt;!--factory-method的值是FactoryHelloAction中的工厂方法名createInstance--&gt;<br />&lt;bean id="helloAction" class="org.yoo.di.FactoryHelloAction" factory-method="createInstance"&gt;<br />&lt;constructor-arg type="java.lang.String" value="yoo"/&gt;<br />&lt;constructor-arg&gt;&lt;ref bean="helloService"/&gt;&lt;/constructor-arg&gt;<br />&lt;/bean&gt;</p>

<p>action实现类：</p>
<p>private HelloServiceImpl helloservice;<br />private String name = null;</p>
<p>private SpringFactoryHelloAction(String name ,HelloServiceImpl helloservice){<br />this.helloservice = helloservice ;<br />this.name = name ;<br />}</p>
<p>public static SpringFactoryHelloAction createInstance(String name ,HelloServiceImpl helloservice) {<br />SpringFactoryHelloAction fha = new SpringFactoryHelloAction (name,helloservice);<br />// some other operations<br />return fha;<br />}</p>
<p>@Override<br />public void sayHello() {<br />helloservice.sayHello();<br />System.out.println(this.name);<br />}<br /><strong>四 无配置文件注入（自动注入）</strong></p>
<p>上面三种方法都需要编写配置文件，在spring2.5中还提供了不编写配置文件的ioc实现。需要注意的是，无配置文件指bean之间依赖，不基于配置文件，而不是指没有spring配置文件。</p>
<p>配置文件如下：</p>
<p>&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />&lt;beans xmlns="<a href="http://www.springframework.org/schema/beans" rel="external nofollow noreferrer">http://www.springframework.org/schema/beans</a>"<br />xmlns:xsi="<a href="http://www.w3.org/2001/XMLSchema-instance" rel="external nofollow noreferrer">http://www.w3.org/2001/XMLSchema-instance</a>"<br />xsi:schemaLocation="<a href="http://www.springframework.org/schema/beans" rel="external nofollow noreferrer">http://www.springframework.org/schema/beans</a><br /><a href="http://www.springframework.org/schema/beans/spring-beans-2.5.xsd" rel="external nofollow noreferrer">http://www.springframework.org/schema/beans/spring-beans-2.5.xsd</a>"&gt;<br />&lt;bean class="org.springframework.beans.factory.annotation.AutowiredAnnotationBeanPostProcessor"/&gt;<br />&lt;bean id="helloService" class="org.yoo.service.HelloServiceImpl"&gt;<br />&lt;/bean&gt;<br />&lt;bean id="helloAction" class="org.yoo.action.AutowiredHelloAction"&gt;<br />&lt;/bean&gt;<br />&lt;/beans&gt;</p>
<p>可见上面只是设置了helloService和helloAction两个bean，并没有设置helloAction对helloService的依赖。</p>
<p>另外&lt;bean class="org.springframework.beans.factory.annotation.AutowiredAnnotationBeanPostProcessor"/&gt;是必须的，有此才支持自动注入。</p>
<p>action实现类：</p>
<p>/*<br />* 属性自动装载<br />*/<br />/*<br />@Autowired<br />private HelloService helloservice;</p>
<p>@Override<br />public void sayHello() {<br />helloservice.sayHello();<br />。<br />上面代码很简单，在属性上加上 @Autowired注释，spring会自动注入HelloService 。</p>
<p>同样也支持构造器和setteer方法的注入，如下：</p>
<p>构造器自动注入：</p>
<p>/*<br />* 还可以使用构造函数设置<br />*/<br />@Autowired<br />public SpringAutowiredHelloAction(HelloServiceImpl helloservice){<br />this.helloservice = helloservice;<br />}</p>
<p>setter方法自动注入：</p>
<p>/*<br />* 也可以使用set方法设置<br />*/<br />/*<br />@Autowired<br />public void setHelloservice(HelloService helloservice) {<br />this.helloservice = helloservice;<br />}</p>
<p>最后在spring的reference文档中有提到，如果不使用自动注入，尽量使用setter方法，一般通用的也是使用setter方法。</p>
<p>而使用自动注入还是配置文件方式，如果jdk低于1.5或者spring不是2.5，就只能够使用配置文件方式了。其它的就看实际项目选择了。</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ody4lq.html">mongo-c-driver使用VS2013编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6kpvq.html">action func用法记记</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k45z39.html">Java 代码编译和执行的整个过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1olp58.html">HR外包系统 - 账款</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j64v0q.html">rJava包---R与Java的接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rvw378.html">ubuntu解决arm-linux-gcc no such file的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0r7dq.html">Aho-Corasick算法、多模正则匹配、Snort入门学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdoxk9.html">QAQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m0201q.html">js jquery版本的 金额千分位转换函数（非正则，效率极高）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wl30vq.html">C&plus;&plus;中delete和 delete&lbrack;&rsqb;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv154lxq.html">IOI2014 day2 task4 Holiday</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ppnrn8.html">【J2SE】java实现简单照片查看器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4grm9.html">使用EntityFramework持久化聚合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z0x2x9.html">关于Struts与Ajax整合时的异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zyzlx9.html">&lpar;NO&period;00001&rpar;iOS游戏SpeedBoy Lite成形记&lpar;二十八&rpar;&colon;增加排行榜功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyn2wgq.html">【java并发核心二】Exchanger的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ov03k8.html">最近无意中看到一个讲解spring mvc的系列，从源码的角度讲解，特记录下来，供以后反复学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvrv6j8.html">django中url，静态文件，POST请求的配置                                                       分类：            Python             2015-06-01 17&colon;00    789人阅读    评论&lpar;0&rpar;    收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rw30m9.html">Android 优秀开源项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzn2jq.html">c&plus;&plus; strcmp strcpy sprintf</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pyegn8.html">关于前后端同构，我的一点思路和心得（vue、nodejs、react、模版、amd）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mew10oq.html">maven项目转成web项目没有生成WebContent目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yvejz8.html">【Python3之基本数据类型，基本运算】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyjn3m9.html">Java NIO学习笔记七     Non-blocking Server</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yv5v08.html">EF架构~Migration数据迁移的执行顺序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mewg66q.html">【解决】安装compass失败&lpar;gem install compass&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950w62e8.html">html中p标签行间距的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpvwy59.html">GitHub&colon;多人协作下的分支处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpv31r9.html">Linux网络编程客户&bsol;服务器设计范式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mewoz6q.html">Transparent Application Failover 透明应用切换</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
